<?php
class Guestbook
 {
  var $entries = false;
  var $form = false;
  var $errors = false;
  var $entry_info;
  var $edit_form = false;
  var $preview = false;
  var $guestbook_page = 1;

  function guestbook($db_content, $db_entries, $guestbook_table, $wordfilter_table, $guestbook_id, $page)
   {
    global $config, $settings, $lang;
    
    if(isset($_POST['delete_entry']) && isset($_SESSION[$settings['session_prefix'].'user_id']))
     {
      sqlite_query($db_entries, "DELETE FROM ".$guestbook_table." WHERE id = ".intval($_POST['entry_id']));
      
      // clear cache:
      if($settings['caching']==1)
       {
        $cachefile = "../cache/".$page.".cache";
        if(file_exists($cachefile)) @unlink($cachefile);
        unset($cachefile);
        foreach(glob("../cache/".$page.",*.cache") as $cachefile) 
         {
          @unlink($cachefile);
         }
       }
      
      if(isset($_POST['browse_page'])) $browse_page = intval($_POST['browse_page']);
      else $browse_page = 1;
      header('location: '.$page.','.$browse_page);
      exit;
     }

    if(isset($_POST['edit_entry']) && isset($_SESSION[$settings['session_prefix'].'user_id']))
     {
      $result = sqlite_query($db_entries, "SELECT id, name, location, email_hp, entry, comment FROM ".$guestbook_table." WHERE id = ".$_POST['entry_id']." LIMIT 1");
      $data = sqlite_fetch_array($result);
      $this -> edit_form['entry_id'] = $data['id'];
      $this -> edit_form['name'] = htmlspecialchars(stripslashes($data['name']));
      $this -> edit_form['location'] = htmlspecialchars(stripslashes($data['location']));
      $this -> edit_form['email_hp'] = htmlspecialchars(stripslashes($data['email_hp']));
      $this -> edit_form['entry'] = htmlspecialchars(stripslashes($data['entry']));
      $this -> edit_form['comment'] = htmlspecialchars(stripslashes($data['comment']));
      if (isset($_POST['browse_page'])) $browse_page = intval($_POST['browse_page']); else $browse_page = 1;
      $this -> edit_form['browse_page'] = $browse_page;
     }

    if(isset($_POST['guestbook_edit_submit']) && isset($_SESSION[$settings['session_prefix'].'user_id']))
     {
      sqlite_query($db_entries, "UPDATE ".$guestbook_table." SET time=time, name='".sqlite_escape_string($_POST['name'])."', location='".sqlite_escape_string($_POST['location'])."', email_hp='".sqlite_escape_string($_POST['email_hp'])."', entry='".sqlite_escape_string($_POST['entry'])."', comment='".sqlite_escape_string($_POST['comment'])."' WHERE id = ".intval($_POST['entry_id']));

      // clear cache:
      if($settings['caching']==1)
       {
        $cachefile = "../cache/".$page.".cache";
        if(file_exists($cachefile)) @unlink($cachefile);
        unset($cachefile);
        foreach(glob("../cache/".$page.",*.cache") as $cachefile) 
         {
          @unlink($cachefile);
         }
       }
      
      header('location: '.$page.','.intval($_POST['browse_page']));
      exit;
     }

    // if comment entered:
    if (isset($_POST['entry']))
     {
      $entry = trim($_POST['entry']);
      $name = trim($_POST['name']);
      $location = trim($_POST['location']);
      $email_hp = trim($_POST['email_hp']);
      if (substr($email_hp,0,7) == "http://") $email_hp = substr($email_hp,7);

    $error_nr = 0;

    // check for not accepted words:
    $result = @sqlite_query($db_content, "SELECT list FROM ".$wordfilter_table." WHERE name = 'words' LIMIT 1");
    $data = sqlite_fetch_array($result);
    if(trim($data['list']) != '')
     {
      $not_accepted_words = explode(',',trim($data['list']));
      foreach($not_accepted_words as $not_accepted_word)
       {
        if($not_accepted_word!='' && (preg_match("/".$not_accepted_word."/i",$name) || preg_match("/".$not_accepted_word."/i",$location) || preg_match("/".$not_accepted_word."/i",$email_hp) || preg_match("/".$not_accepted_word."/i",$entry)))
         {
          $this -> errors[$error_nr][0] = 0;
          $error_nr++;
          break;
         }
       }
     }

    if($name == '')
     {
      $this -> errors[$error_nr][0] = 1;
      $error_nr++;
     }
    if($entry == '')
     {
      $this -> errors[$error_nr][0] = 2;
      $error_nr++;
     }
    if(strlen($name) > $settings['name_maxlength'])
     {
      $this -> errors[$error_nr][0] = 3;
      $error_nr++;
     }
    if(strlen($location) > $settings['location_maxlength'])
     {
      $this -> errors[$error_nr][0] = 4;
      $error_nr++;
     }
    if(strlen($email_hp) > $settings['email_hp_maxlength'])
     {
      $this -> errors[$error_nr][0] = 5;
      $error_nr++;
     }
    /*
    if (strlen($_POST['comment_text']) > $settings['comment_maxlength']) { $err_txt_too_lng = str_replace("[characters]", strlen($_POST['comment_text']), $lang['err_text_too_long']); $err_txt_too_lng = str_replace("[characters_max]", $settings['comment_maxlength'], $err_txt_too_lng); $this -> errors[][0] = 1; }
    */
    if (strlen($_POST['entry']) > $settings['guestbook_entry_maxlength'])
     {
      $this -> errors[$error_nr][0] = 6;
      $error_nr++;
     }

    $text_arr = str_replace("\n", " ", $_POST['entry']);
    /*
    $text_arr = explode(" ",$text_arr); for ($i=0;$i<count($text_arr);$i++) { trim($text_arr[$i]); $laenge = strlen($text_arr[$i]); if ($laenge > $settings['comment_word_maxlength']) { $this -> errors[] = str_replace("[word]", "\"".htmlspecialchars(stripslashes(substr($text_arr[$i],0,$settings['comment_word_maxlength'])))."...\"", $lang['err_word_too_long']); } }
    */

    $text_arr = explode(" ",$text_arr);
    for ($i=0;$i<count($text_arr);$i++)
     {
      trim($text_arr[$i]); $laenge = strlen($text_arr[$i]);
      if ($laenge > $settings['word_maxlength'])
       {
        $this -> errors[$error_nr][0] = 7;
        $this -> errors[$error_nr][1] = htmlspecialchars(stripslashes(substr($text_arr[$i],0,$settings['word_maxlength']))).'...';
        $error_nr++;
       }
      }

    // check for double and repeated entries:
   $check_result = sqlite_query($db_entries,"SELECT COUNT(*) FROM ".$guestbook_table." WHERE time > (strftime('%s','now')-3600) AND guestbook_id = '".sqlite_escape_string($guestbook_id)."' AND name = '".sqlite_escape_string($name)."' AND email_hp = '".sqlite_escape_string($email_hp)."' AND entry = '".sqlite_escape_string($entry)."'");
   list($double_count) = sqlite_fetch_array($check_result);
   if ($double_count > 0) { $this -> errors[$error_nr][0] = 8; $error_nr++; }
   if ($settings['guestbook_prevent_repeated_posts'] > 0)
    {
     $check_result = sqlite_query($db_entries,"SELECT COUNT(*) FROM ".$guestbook_table." WHERE time > (strftime('%s','now')-(".$settings['guestbook_prevent_repeated_posts']."*60)) AND guestbook_id = ".sqlite_escape_string($guestbook_id)." AND ip = '".sqlite_escape_string($_SERVER["REMOTE_ADDR"])."'");
     list($ip_count) = sqlite_fetch_array($check_result);
     if ($ip_count > 0) { $this -> errors[$error_nr][] = 9; $error_nr++; }
    }
   
   // Akismet spam check:
   if($settings['akismet_key']!='' && $settings['akismet_comment_check']==1 && isset($_POST['guestbook_submit']))
    {
     #require('modules/akismet/Akismet.class.php');
     $akismet = new Akismet(BASE_URL, $settings['akismet_key']);
     if($name != '') $akismet->setCommentAuthor($name);
     if($email_hp != '')
      {
       if(preg_match("/^[^@]+@.+\.\D{2,5}$/", $email_hp)) $akismet->setCommentAuthorEmail($email_hp);
       else $akismet->setCommentAuthorURL($email_hp);
      }
     if($entry != '') $akismet->setCommentContent($entry);
     if($akismet->isCommentSpam())
      {
       $this -> errors[$error_nr][] = 10; $error_nr++;
      }
    }

   if ($this -> errors == false)
    {
     if(isset($_POST['guestbook_preview']))
      {
       $this -> preview['name'] = htmlspecialchars(stripslashes($_POST['name']));
       $this -> preview['location'] = htmlspecialchars(stripslashes($_POST['location']));
       $this -> preview['timestamp'] = time();
       $this -> preview['time'] = format_time($lang['time_format_full'],time());

       $entry = trim(htmlspecialchars(stripslashes($_POST['entry'])));
       if($settings['entries_delete_whitespace']==1)
        {
         $entry_array = explode("\n", $entry);
         $entry = '';
         foreach($entry_array as $entry_line)
          {
          $entry_line = trim($entry_line);
          if($entry_line!='') $entry .= $entry_line."\n";
          }
        }
       $entry = nl2br($entry);

       #$entry = nl2br(trim(htmlspecialchars(stripslashes($_POST['entry']))));
       if($settings['guestbook_auto_link']==1) $entry = $this->make_link($entry);
       if($settings['guestbook_bbcode']==1) $entry = $this->bbcode($entry);
       if($settings['guestbook_smilies']==1) $entry = $this->smilies($entry);
       $this -> preview['entry'] = $entry;
       $email_hp = htmlspecialchars(stripslashes($_POST['email_hp']));
       if(preg_match("/^[^@]+@.+\.\D{2,5}$/", $email_hp))
        {
         if($settings['entries_show_email']==1) $this -> preview['email'] = $email_hp;
        } 
       else $this -> preview['homepage'] = 'http://'.$email_hp;
      }
     elseif(isset($_POST['guestbook_submit']))
      {
       sqlite_query($db_entries, "INSERT INTO ".$guestbook_table." (guestbook_id, time, ip, name, location, email_hp, entry) VALUES ('".sqlite_escape_string($guestbook_id)."',strftime('%s','now'),'".sqlite_escape_string($_SERVER["REMOTE_ADDR"])."','".sqlite_escape_string($name)."','".sqlite_escape_string($location)."','".sqlite_escape_string($email_hp)."','".sqlite_escape_string($entry)."')");
       
       // clear cache:
       if($settings['caching']==1)
        {
         $cachefile = "../cache/".$page.".cache";
         if(file_exists($cachefile)) @unlink($cachefile);
         unset($cachefile);
         foreach(glob("../cache/".$page.",*.cache") as $cachefile) 
          {
           @unlink($cachefile);
          }
        }
       
       // E-mail notification to admin:
       if ($settings['guestbook_notification'] == 1 && $settings['email'] != '')
        {
         $sender_name = trim($name);
         if (preg_match("/^[^@]+@.+\.\D{2,5}$/", $email_hp)) $sender_email = $email_hp; else $sender_email = "email@unknown.xx";
         $email_text = str_replace("[name]",stripslashes($sender_name),$lang['gb_email_not_text']);
         $email_text = str_replace("[message]",stripslashes($entry),$email_text);
         $emailbody = str_replace("[link]",BASE_URL.$page,$email_text);
         $header= "From: ".stripslashes($sender_name)." <".stripslashes($sender_email).">\n";
         $header .= "X-Mailer: PHP/" . phpversion(). "\n";
         $header .= "X-Sender-IP: ".$_SERVER["REMOTE_ADDR"]."\n";
         $header .= "Content-Type: text/plain; charset=".$lang['charset']."\n";
         $header .= "Content-transfer-encoding: 8bit\n";
         if($settings['mail_parameter']!='') @mail($settings['email'], $lang['gb_email_not_subject'], $emailbody, $header, $settings['mail_parameter']);
         else @mail($settings['email'], $lang['gb_email_not_subject'], $emailbody, $header);
        }
       header('location: '.$page);
       exit;
      }
     }
    }

    #if(empty($_GET['get_2'])) $this -> entries($db_entries, $guestbook_table, $guestbiik_id, $page);
    #else $this -> form($db_entries, $guestbook_table, $guestbiik_id, $page);
    $this->db_entries = $db_entries;
    $this->guestbook_table = $guestbook_table;
    $this->guestbook_id = $guestbook_id;
    $this->page = $page;
    $this->form = $this->form();
   }

  function entries()
   {
    global $settings, $lang;

    if((empty($_GET['get_1']) || isset($_GET['get_1']) && $_GET['get_1']!='new_entry') && empty($_POST['guestbook_submit']) && empty($_POST['guestbook_preview']) && empty($_POST['edit_entry']))
    {
    $entry_count = $this->count_comments($this->db_entries, $this->guestbook_table, $this->guestbook_id);
    $guestbook_pages = ceil($entry_count / $settings['guestbook_entries_per_page']);
    if (isset($_GET['get_1'])) $guestbook_page = intval($_GET['get_1']); else $guestbook_page = 1;
    if($guestbook_page==0) $guestbook_page = 1;
    if($guestbook_page > $guestbook_pages) $guestbook_page = $guestbook_pages;
    
    $this->guestbook_page = $guestbook_page;

    $result = sqlite_query($this->db_entries, "SELECT id, time, name, location, email_hp, entry, comment, ip FROM ".$this->guestbook_table." WHERE guestbook_id = '".$this->guestbook_id."' ORDER BY id DESC LIMIT ".(($guestbook_page-1)*$settings['guestbook_entries_per_page']).", ".$settings['guestbook_entries_per_page']);

    $i = 0;
    $displayed_entries=0;
    while ($data = sqlite_fetch_array($result))
     {
      $displayed_entries++;
      $name = htmlspecialchars(stripslashes($data['name']));
      if($data['email_hp'] != "")
       {
        $email_hp = htmlspecialchars(stripslashes($data['email_hp']));
        if (preg_match("/^[^@]+@.+\.\D{2,5}$/", $email_hp)) 
         {
          if($settings['entries_show_email']==1) $this -> entries[$i]['email'] = $email_hp;
         } 
        else $this -> entries[$i]['homepage'] = 'http://'.$email_hp;
       }

      $entry = trim(htmlspecialchars(stripslashes($data['entry'])));
      if($settings['entries_delete_whitespace']==1)
       {
        $entry_array = explode("\n", $entry);
        $entry = '';
        foreach($entry_array as $entry_line)
         {
          $entry_line = trim($entry_line);
          if($entry_line!='') $entry .= $entry_line."\n";
         }
       }
      $entry = nl2br($entry);
      if ($settings['guestbook_auto_link']==1) $entry = $this->make_link($entry);
      if ($settings['guestbook_bbcode']==1) $entry = $this->bbcode($entry);
      if($settings['guestbook_smilies']==1) $entry = $this->smilies($entry);
      $comment = nl2br(trim(htmlspecialchars(stripslashes($data['comment']))));
      if ($settings['guestbook_auto_link']==1) $comment = $this->make_link($comment);
      if ($settings['guestbook_bbcode']==1) $comment = $this->bbcode($comment);
      if($settings['guestbook_smilies']==1) $comment = $this->smilies($comment);

      $this -> entries[$i]['id'] = $data['id'];
      $this -> entries[$i]['name'] = $name;
      $this -> entries[$i]['location'] = htmlspecialchars(stripslashes($data['location']));
      $this -> entries[$i]['timestamp'] = $data['time'];
      $this -> entries[$i]['time'] = format_time($lang['time_format_full'], $data['time']);
      $this -> entries[$i]['entry'] = $entry;
      $this -> entries[$i]['comment'] = $comment;
      $this -> entries[$i]['ip'] = $data['ip'];
      $i++;
     }

    $browse_array[] = 1;
    if ($guestbook_page > 5) $browse_array[] = 0;
    for($guestbook_page_browse=$guestbook_page-3; $guestbook_page_browse<$guestbook_page+4; $guestbook_page_browse++)
     {
      if ($guestbook_page_browse > 1 && $guestbook_page_browse < $guestbook_pages) $browse_array[] = $guestbook_page_browse;
     }
    if ($guestbook_page < $guestbook_pages-4) $browse_array[] = 0;
    if ($guestbook_pages > 1) $browse_array[] = $guestbook_pages;
    if($guestbook_page < $guestbook_pages) $next_page = $guestbook_page + 1; else $next_page = 0;
    if($guestbook_page > 1) $previous_page = $guestbook_page - 1; else $previous_page = 0;

    $this -> entry_info = array($entry_count, $displayed_entries, $guestbook_page, $guestbook_pages, $previous_page, $next_page, $settings['guestbook_entries_per_page'], $browse_array);
    return $this->entries;
    } // end if(empty($_GET['get_2']))
    else return false;
   }

 function form()
  {
   if(isset($_GET['get_1']) && $_GET['get_1']=='new_entry' || isset($_POST['entry']) || isset($_POST['preview']))
    {
     if(isset($_POST['entry'])) $this->form['entry'] = htmlspecialchars(stripslashes($_POST['entry'])); else $this->form['entry']='';
     if(isset($_POST['name'])) $this->form['name'] = htmlspecialchars(stripslashes($_POST['name'])); else $this->form['name']='';
     if(isset($_POST['location'])) $this->form['location'] = htmlspecialchars(stripslashes($_POST['location'])); else $this->form['location']='';
     if(isset($_POST['email_hp'])) $this->form['email_hp'] = htmlspecialchars(stripslashes($_POST['email_hp'])); else $this->form['email_hp']='';
     return $this->form;
    }
   else return false;
  }

 function make_link($string)
 {
  $string = ' ' . $string;
  $string = preg_replace("#(^|[\n ])([\w]+?://.*?[^ \"\n\r\t<]*)#is", "\\1<a href=\"\\2\">\\2</a>", $string);
  $string = preg_replace("#(^|[\n ])((www|ftp)\.[\w\-]+\.[\w\-.\~]+(?:/[^ \"\t\n\r<]*)?)#is", "\\1<a href=\"http://\\2\">\\2</a>", $string);
  $string = preg_replace("#(^|[\n ])([a-z0-9&\-_.]+?)@([\w\-]+\.([\w\-\.]+\.)*[\w]+)#i", "\\1<a href=\"mailto:\\2@\\3\">\\2@\\3</a>", $string);
  $string = substr($string, 1);
  return $string;
 }

function smilies($string)
 {
  global $settings;
  require 'config/smilies.conf.php';
  foreach($smilies as $smiley)
   {
    $string = str_replace($smiley[0], "<img src=\"".$settings['smiley_directory']."/".$smiley[1]."\" alt=\"".$smiley[0]."\" />", $string);
   }
  return $string;
 }

 function bbcode($string)
 {
  $string = preg_replace("#\[b\](.+?)\[/b\]#is", "<b>\\1</b>", $string);
  $string = preg_replace("#\[i\](.+?)\[/i\]#is", "<i>\\1</i>", $string);
  $string = preg_replace("#\[u\](.+?)\[/u\]#is", "<u>\\1</u>", $string);
  $string = preg_replace("#\[link\]www\.(.+?)\[/link\]#is", "<a href=\"http://www.\\1\">www.\\1</a>", $string);
  $string = preg_replace("#\[link\](.+?)\[/link\]#is", "<a href=\"\\1\">\\1</a>", $string);
  $string = preg_replace("#\[link=(.+?)\](.+?)\[/link\]#is", "<a href=\"\\1\">\\2</a>", $string);
  $string = preg_replace("#\[url\]www\.(.+?)\[/url\]#is", "<a href=\"http://www.\\1\">www.\\1</a>", $string);
  $string = preg_replace("#\[url\](.+?)\[/url\]#is", "<a href=\"\\1\">\\1</a>", $string);
  $string = preg_replace("#\[url=(.+?)\](.+?)\[/url\]#is", "<a href=\"\\1\">\\2</a>", $string);
  return $string;
 }

 function count_comments($db_entries, $guestbook_table, $guestbook_id, $text=0)
  {
   global $comment_settings, $comment_lang;
   $count_result = sqlite_query($db_entries, "SELECT COUNT(*) FROM ".$guestbook_table." WHERE guestbook_id = '".$guestbook_id."'");
   list($comment_count) = sqlite_fetch_array($count_result);

   if ($text == 0) return $comment_count;
   else
    {
     if ($comment_count == 0) $count_text = $lang['no_comments'];
     elseif ($comment_count == 1) $count_text = $lang['one_comment'];
     else $count_text = str_replace("[comments]", $comment_count, $lang['several_comments']);
     return $count_text;
    }
   }
 }
?>
