<?php
// autoload required classes:
function __autoload($class_name)
 {
  require_once('includes/classes/'.$class_name.'.class.php');
 }

function db_error()
 {
  global $error_503;
  header($_SERVER['SERVER_PROTOCOL'] . " 503 Service Unavailable");
  header("Status: 503 Service Unavailable");  
  echo $error_503;
  exit;
 }
 
function auto_html($text)
 {
  $text = trim($text);
  if($text!='')
   {
    #$text = preg_replace('/\[\[([^|\]]+?)(?:\|([^\]]+))?\]\]/e', "'<a href=\"\$1\">'.(('\$2')?'\$2':'\$1').'</a>'", $text);
    $text = '<p>' . $text . '</p>';
    $text = preg_replace("/(\015\012\015\012)|(\015\015)|(\012\012)/","</p><p>",$text);
    $text = nl2br($text);
   }
  return $text;
 }

function content_function($function)
 {
  return @eval('return '.$function[1].';');
 }

function myFunction($x,$y)
 {
  return $x + $y;
 }
 
function create_image($string)
 {
  global $db_content, $db_settings, $page;
  $string = explode('|',$string[1]);
  $image = $string[0];
  if(isset($string[1]) && $string[1]!='') $img_class = $string[1];
  if(isset($string[2])) $img_alt = $string[2];
  else $img_alt = 'image';
  if(file_exists('../images/'.$image))
   {
    $image_info = getimagesize('../images/'.$image);
    $width = $image_info[0];
    $height = $image_info[1];
    if(isset($img_class)) $image = '<img class="'.$img_class.'" src="images/'.$image.'" title="'.htmlspecialchars(strip_tags(stripslashes($img_alt))).'" alt="'.htmlspecialchars(strip_tags(stripslashes($img_alt))).'" width="'.$width.'" height="'.$height.'" />';
    else $image = '<img src="images/'.$image.'" title="'.htmlspecialchars(strip_tags(stripslashes($img_alt))).'" alt="'.htmlspecialchars(strip_tags(stripslashes($img_alt))).'" width="'.$width.'" height="'.$height.'" />';
   }
  else
   {
    if($img_alt!='image') $missing_image = ' missing image: ' . stripslashes($img_alt) . ' '; else $missing_image = ' missing image ';
    $image = '<span style="color:red;">['.$missing_image.']</span>';
   }
  return $image;
 }

function create_thumbnail($string)
 {
  global $db_content, $db_settings, $page;
  $string = explode('|',$string[1]);
  $id = intval($string[0]);
  if(isset($string[1])) $img_class = $string[1];

  $result = sqlite_query($db_content, "SELECT photo_thumbnail, title FROM ".$db_settings['photo_table']." WHERE id = ".$id." LIMIT 1");
  if (sqlite_num_rows($result) == 1)
   {
    $data = sqlite_fetch_array($result);
    $thumbnail_info = getimagesize('../images/'.$data['photo_thumbnail']);
    $width = $thumbnail_info[0];
    $height = $thumbnail_info[1];
    if(isset($img_class)) $thumbnail = '<a href="'.$page.',photo,'.$id.'"><img class="'.$img_class.'" src="images/'.$data['photo_thumbnail'].'" title="'.htmlspecialchars(strip_tags(stripslashes($data['title']))).'" alt="'.htmlspecialchars(strip_tags(stripslashes($data['title']))).'" width="'.$width.'" height="'.$height.'" /></a>';
    else $thumbnail = '<a href="'.$page.',photo,'.$id.'"><img src="images/'.$data['photo_thumbnail'].'" title="'.htmlspecialchars(strip_tags(stripslashes($data['title']))).'" alt="'.htmlspecialchars(strip_tags(stripslashes($data['title']))).'" width="'.$width.'" height="'.$height.'" /></a>';
   }
  else
   {
    $thumbnail = '<span style="color:red;">[ missing image ]</span>';
   }
  return $thumbnail;
 }

function create_gallery($string)
 {
  global $db_content, $db_settings, $page;
  $string = explode('|',$string[1]);
  $gallery = $string[0];
  if(isset($string[1])) $img_class = $string[1];

  $result = sqlite_query($db_content, "SELECT id, photo_thumbnail, title FROM ".$db_settings['photo_table']." WHERE gallery = '".$gallery."' ORDER BY item_id ASC");
  if (sqlite_num_rows($result) > 0)
   {
    $thumbnail = '';
    while($data = sqlite_fetch_array($result))
     {
      $thumbnail_info = getimagesize('../images/'.$data['photo_thumbnail']);
      $width = $thumbnail_info[0];
      $height = $thumbnail_info[1];
      if(isset($img_class)) $thumbnail .= '<a href="'.$page.',photo,'.$data['id'].'"><img class="'.$img_class.'" src="images/'.$data['photo_thumbnail'].'" title="'.htmlspecialchars(strip_tags(stripslashes($data['title']))).'" alt="'.htmlspecialchars(strip_tags(stripslashes($data['title']))).'" width="'.$width.'" height="'.$height.'" /></a>';
      else $thumbnail .= '<a href="'.$page.',photo,'.$data['id'].'"><img src="images/'.$data['photo_thumbnail'].'" title="'.htmlspecialchars(strip_tags(stripslashes($data['title']))).'" alt="'.htmlspecialchars(strip_tags(stripslashes($data['title']))).'" width="'.$width.'" height="'.$height.'" /></a>';
     }
   }
  else
   {
    $thumbnail = '<span style="color:red;">[ missing image ]</span>';
   }
  return $thumbnail;
 }

function make_link($string)
 {
  $string = ' ' . $string;
  $string = preg_replace("#(^|[\n ])([\w]+?://.*?[^ \"\n\r\t<]*)#is", "\\1<a href=\"\\2\">\\2</a>", $string);
  $string = preg_replace("#(^|[\n ])((www|ftp)\.[\w\-]+\.[\w\-.\~]+(?:/[^ \"\t\n\r<]*)?)#is", "\\1<a href=\"http://\\2\">\\2</a>", $string);
  $string = preg_replace("#(^|[\n ])([a-z0-9&\-_.]+?)@([\w\-]+\.([\w\-\.]+\.)*[\w]+)#i", "\\1<a href=\"mailto:\\2@\\3\">\\2@\\3</a>", $string);
  $string = substr($string, 1);
  return $string;
 }

function smilies($string)
 {
  global $settings;
  require 'config/smilies.conf.php';
  foreach($smilies as $smiley)
   {
    $string = str_replace($smiley[0], "<img src=\"".$settings['smiley_directory']."/".$smiley[1]."\" alt=\"".$smiley[0]."\" />", $string);
   }
  return $string;
 }

function format_time($format, $timestamp=0)
 {
  global $lang;
  if($timestamp==0) $timestamp=time();
  if($lang['server_default_charset']!=$lang['charset'] && function_exists('iconv'))
   {
    $formated_time = iconv($lang['server_default_charset'],$lang['charset'],strftime($format,$timestamp));
   }
  else
   {
    $formated_time = strftime($format,$timestamp);
   }  
  return $formated_time;
 }

/**
 * generates a random string
 *
 * @param int $length
 * @param string $characters 
 * @return string 
 */ 
function random_string($length=8,$characters='abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789')
 {
  $random_string = '';
  $characters_length = strlen($characters);
  for($i=0;$i<$length;$i++)
   {
    $random_string .= $characters[mt_rand(0, $characters_length - 1)];
   }
  return $random_string;
 } 

/**
 * generates password hash
 *
 * @param string $pw 
 * @return string 
 */ 
function generate_pw_hash($pw)
 {
  $salt = random_string(10,'0123456789abcdef');
  $salted_hash = sha1($pw.$salt);
  $hash_with_salt = $salted_hash.$salt;
  return $hash_with_salt;
 } 

/**
 * checks password comparing it with the hash
 *
 * @param string $pw
 * @param string $hash
 * @return bool 
 */ 
function is_pw_correct($pw,$hash)
 {
  if(strlen($hash)==50) // salted sha1 hash with salt
   {
    $salted_hash = substr($hash,0,40);
    $salt = substr($hash,40,10);
    if(sha1($pw.$salt)==$salted_hash) return true;
    else return false;
   }
  else return false;
 } 

function create_chache_file($file, $content)
 {
  $fp = @fopen($file, 'w');
  @flock($fp, 2);
  @fwrite($fp, $content);
  @flock($fp, 3);
  @fclose($fp);
 } 

function create_cache_settings_file($file)
 {
  global $settings;
  $content  = "<?php\n";
  $content .= '$settings[\'session_prefix\'] = \''.$settings['session_prefix'].'\';'."\n";
  $content .= '$settings[\'index_page\'] = \''.$settings['index_page'].'\';'."\n";
  $content .= '$settings[\'caching\'] = '.$settings['caching'].';'."\n";
  $content .= '?'.'>';
  $fp = @fopen($file, 'w');
  @flock($fp, 2);
  @fwrite($fp, $content);
  @flock($fp, 3);
  @fclose($fp);
 }

function clear_cache($cachefile=false)
 {
  if($cachefile)
   {
    @unlink("../cache/".$cachefile);
   }
  else
   {
    if(file_exists('../cache/settings.php')) @unlink('../cache/settings.php');
    foreach(glob("../cache/*.cache") as $cachefile) 
     {
      @unlink($cachefile);
     }
   }
 }

function is_authorized_to_edit($editor,$editor_type,$author,$edit_permission,$edit_permission_general)
 {
  $authorized_users = explode(',',$edit_permission);
  foreach($authorized_users as $authorized_user)
   {
    if(intval($authorized_user)!=0) $cleared_authorized_users[] = $authorized_user;
   }
  if($editor_type>0 || $author==$editor || $edit_permission_general==1 || (isset($cleared_authorized_users) && in_array($editor,$cleared_authorized_users)))
   {
    return true;
   }
  else
   {
    return false;
   }
 }

?>
