<?php
if(!defined('IN_INDEX')) exit;

if(isset($_SESSION[$settings['session_prefix'].'user_id']) && $_SESSION[$settings['session_prefix'].'user_type']==1)
 {
  if (isset($_POST['settings_submitted']))
   {
    if(empty($_POST['caching'])) $_POST['caching'] = 0;
    sqlite_query($db_content, "BEGIN");
    while(list($key, $val) = each($_POST))
     {
      if($key != "settings_submitted") sqlite_query($db_content, "UPDATE ".$db_settings['settings_table']." SET value='".sqlite_escape_string($val)."' WHERE name='".sqlite_escape_string($key)."'");
     }
    sqlite_query($db_content, "COMMIT");
    
    if($settings['caching']==1) clear_cache();
      
    header("location: index.php");
    exit;
   }

  if(isset($_GET['delete']))
   {
    sqlite_query($db_content, "DELETE FROM ".$db_settings['settings_table']." WHERE name='".sqlite_escape_string($_GET['delete'])."'");
    if($settings['caching']==1) clear_cache();
    header("location: ".basename($_SERVER['PHP_SELF'])."?mode=settings&action=advanced_settings");
    exit;
   }

  if (isset($_POST['new_var_submitted']))
   {
    if(!preg_match('/^[a-zA-Z0-9_\-]+$/', $_POST['name']))
     {
      $errors[] = $lang['error_settings_spec_chars'];
      $action = 'advanced_settings';
     }
    if(empty($errors))
     {
      sqlite_query($db_content, "INSERT INTO ".$db_settings['settings_table']." (name,value) VALUES ('".sqlite_escape_string($_POST['name'])."','".sqlite_escape_string($_POST['value'])."')");
      if($settings['caching']==1) clear_cache();
      header("location: ".basename($_SERVER['PHP_SELF'])."?mode=settings&action=advanced_settings");
      exit;
     }
   }

  if(isset($_GET['action'])) $action = $_GET['action'];
  if(empty($action)) $action = 'main_settings';

  include('includes/header.inc.php');

  switch($action)
   {
    case 'main_settings':
     sqlite_query($db_content, "BEGIN");
     $result = sqlite_query($db_content, "SELECT page, title FROM ".$db_settings['content_table']." ORDER BY title ASC");
     $result2 = sqlite_query($db_content, "SELECT page, title FROM ".$db_settings['content_table']." ORDER BY title ASC");
     sqlite_query($db_content, "COMMIT");
     ?><h1><?php echo $lang['settings']; ?></h1>
     <form action="<?php echo basename($_SERVER['PHP_SELF']); ?>" method="post">
     <input type="hidden" name="mode" value="settings" />
     <table class="admin-table" cellspacing="1" cellpadding="5" border="0">
      <tr>
       <td class="c"><label for="website_title"><b><?php echo $lang['settings_website_title']; ?></b></label></td>
       <td class="b"><input id="website_title" type="text" name="website_title" value="<?php echo htmlspecialchars(stripslashes($settings['website_title'])); ?>" size="35" /></td>
      </tr>
      <tr>
       <td class="c"><label for="website_subtitle"><b><?php echo $lang['settings_website_subtitle']; ?></b></label></td>
       <td class="b"><input id="website_subtitle" type="text" name="website_subtitle" value="<?php echo htmlspecialchars(stripslashes($settings['website_subtitle'])); ?>" size="35" /></td>
      </tr>
      <tr>
       <td class="c"><label for="website_footnote_1"><b><?php echo $lang['settings_website_footnote_1']; ?></b></label></td>
       <td class="b"><input id="website_footnote_1" type="text" name="website_footnote_1" value="<?php echo htmlspecialchars(stripslashes($settings['website_footnote_1'])); ?>" size="35" /></td>
      </tr>
      <tr>
       <td class="c"><label for="website_footnote_2"><b><?php echo $lang['settings_website_footnote_2']; ?></b></label></td>
       <td class="b"><input id="website_footnote_2" type="text" name="website_footnote_2" value="<?php echo htmlspecialchars(stripslashes($settings['website_footnote_2'])); ?>" size="35" /></td>
      </tr>
      <!--<tr>
       <td class="c"><?php echo $lang['settings_website_address']; ?></td>
       <td class="b"><input type="text" name="base_url" value="<?php echo htmlspecialchars(stripslashes($settings['base_url'])); ?>" size="35" /></td>
      </tr>-->
      <tr>
       <td class="c"><label for="email"><b><?php echo $lang['settings_email']; ?></b></label></td>
       <td class="b"><input id="email" type="text" name="email" value="<?php echo htmlspecialchars(stripslashes($settings['email'])); ?>" size="35" /></td>
      </tr>
      <tr>
       <td class="c"><label for="index_page"><b><?php echo $lang['settings_index_page']; ?></b></label></td>
       <td class="b"><select id="index_page" name="index_page" size="1"><?php while ($data = sqlite_fetch_array($result)) { ?><option value="<?php echo $data['page']; ?>"<?php if ($settings['index_page']==$data['page']) echo " selected=\"selected\""; ?>><?php echo $data['page']; ?></option><?php } ?></select>
      </tr>
      <tr>
       <td class="c"><label for="error_page"><b><?php echo $lang['settings_error_page']; ?></b></label></td>
       <td class="b"><select id="error_page" name="error_page" size="1"><?php while ($data = sqlite_fetch_array($result2)) { ?><option value="<?php echo $data['page']; ?>"<?php if ($settings['error_page']==$data['page']) echo " selected=\"selected\""; ?>><?php echo $data['page']; ?></option><?php } ?></select>
      </tr>
      <tr>
       <td class="c"><label for="language_file"><b><?php echo $lang['settings_language_file']; ?></b></label></td>
       <td class="b"><select id="language_file" name="language_file" size="1"><?php $handle=opendir('../lang/'); while ($file = readdir($handle)) { if (preg_match('/\.lang$/i', $file)) { ?><option value="<?php echo $file; ?>"<?php if ($settings['language_file'] ==$file) echo " selected=\"selected\""; ?>><?php echo ucfirst(str_replace(".lang","",$file)); ?></option><?php } } closedir($handle); ?></select></td>
      </tr>
      <tr>
       <td class="c"><b><?php echo $lang['settings_caching']; ?></b></td>
       <td class="b"><input id="caching" type="checkbox" name="caching" value="1"<?php if($settings['caching']==1) { ?> checked="checked"<?php } ?>><label for="caching"><?php echo $lang['settings_caching_enabled']; ?></label></td>
      </tr>
      <tr>
       <td class="c">&nbsp;</td>
       <td class="b" style="text-align:right;"><input type="submit" name="settings_submitted" value="<?php echo $lang['submit_button_ok']; ?>" /></td>
      </tr>
     </table>
     </form>
     <p><a href="<?php echo basename($_SERVER['PHP_SELF']); ?>?mode=settings&amp;action=advanced_settings">&raquo; <?php echo $lang['advanced_settings']; ?></a></p><?php
    break;
    case 'advanced_settings';
     ?><h1><?php echo $lang['advanced_settings']; ?></h1><?php
     $result = sqlite_query($db_content, "SELECT name, value FROM ".$db_settings['settings_table']." ORDER BY name ASC");
     if (isset($errors)) { ?><p><span class="caution"><?php echo $lang['error_headline']; ?></span><ul><?php foreach($errors as $error) { ?><li><?php echo $error; ?></li><?php } ?></ul><br /></p><?php }
     ?><form action="<?php echo basename($_SERVER['PHP_SELF']); ?>" method="post">
     <input type="hidden" name="mode" value="settings" />
     <table class="admin-table" cellspacing="1" cellpadding="5" border="0">
     <tr>
      <th><?php echo $lang['settings_name']; ?></th>
      <th><?php echo $lang['settings_value']; ?></th>
      <th>&nbsp;</th>
     </tr><?php
     while ($data = sqlite_fetch_array($result))
      {
       ?><tr>
        <td class="a"><?php echo htmlspecialchars(stripslashes($data['name'])); ?></td>
        <td class="a"><input type="text" name="<?php echo htmlspecialchars(stripslashes($data['name'])); ?>" value="<?php echo htmlspecialchars(stripslashes($data['value'])); ?>" size="25" /></td>
        <td class="a"><a href="<?php echo basename($_SERVER['PHP_SELF']); ?>?mode=settings&amp;delete=<?php echo htmlspecialchars(stripslashes($data['name'])); ?>"><img src="img/delete.png" alt="<?php echo $lang['delete']; ?>" title="<?php echo $lang['delete']; ?>" width="16" height="16" /></a></td>
       </tr><?php
      }
      ?><tr>
        <td class="b" colspan="2" style="text-align:right;"><input type="submit" name="settings_submitted" value="<?php echo $lang['submit_button_ok']; ?>" /></td>
        <td class="b">&nbsp;</td>
       </tr>
      </table>
     </form>

     <p style="margin-top:30px;"><?php echo $lang['add_new_setting_var']; ?></p>
     <form action="<?php echo basename($_SERVER['PHP_SELF']); ?>" method="post">
     <input type="hidden" name="mode" value="settings" />
      <table class="admin-table" cellspacing="1" cellpadding="5" border="0">
       <tr>
        <th><?php echo $lang['settings_name']; ?></th>
        <th><?php echo $lang['settings_value']; ?></th>
       </tr>
       <tr>
        <td class="a"><input type="text" name="name" value="" size="25"/></td>
        <td class="a"><input type="text" name="value" value="" size="25" /></td>
       </tr>
       <tr>
        <td class="b" colspan="2" style="text-align:right;"><input type="submit" name="new_var_submitted" value="<?php echo $lang['submit_button_ok']; ?>" /></td>
       </tr>
      </table>
     </form><?php
    break;
   }
  include('includes/footer.inc.php');
 }
