<?php
/******************************************************************************
* phpSQLiteCMS - a simple and lightweight PHP web content management system   *                                                               *
* Copyright (C) 2008 alex@mylittlehomepage.net                                *
* http://phpsqlitecms.net/                                                    *
******************************************************************************/

/*******************************************************************************
* This program is free software: you can redistribute it and/or modify         *
* it under the terms of the GNU General Public License as published by         *
* the Free Software Foundation, either version 3 of the License, or            *
* (at your option) any later version.                                          *
*                                                                              *
* This program is distributed in the hope that it will be useful,              *
* but WITHOUT ANY WARRANTY; without even the implied warranty of               *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
* GNU General Public License for more details.                                 *
*                                                                              *
* You should have received a copy of the GNU General Public License            *
* along with this program.  If not, see <http://www.gnu.org/licenses/>.        *
*******************************************************************************/

session_start();
define('IN_INDEX', TRUE);
include('config/db_settings.conf.php');
include('includes/functions.inc.php');

// SQLite database connection:
if(!$db_content = @sqlite_open($db_settings['db_content_file'])) die('Content data file error!');
if(!$db_entries = @sqlite_open($db_settings['db_entry_file'])) die('Entries data file error!');
if(!$db_userdata = @sqlite_open($db_settings['db_userdata_file'])) die('Userdata file error!');

// settings:
$settings_result = sqlite_query($db_content, "SELECT name, value FROM ".$db_settings['settings_table']);
while ($line = sqlite_fetch_array($settings_result))
 {
  $settings[$line['name']] = stripslashes($line['value']);
 }

// define BASE_URL from settings or automatically:
if($settings['base_url']=='') define('BASE_URL', 'http://'.$_SERVER['HTTP_HOST'].substr(rtrim(dirname($_SERVER['PHP_SELF']), '/\\'),0,strrpos(rtrim(dirname($_SERVER['PHP_SELF']), '/\\'),'/cms')).'/');
else define('BASE_URL',$settings['base_url']);

if(isset($_GET['clear_cache']) && isset($_SESSION[$settings['session_prefix'].'user_type']) && $_SESSION[$settings['session_prefix'].'user_type']==1 && $settings['caching']==1)
 {
  clear_cache();
  header('Location: ../');
  exit;
 }

// include smarty config file (language file):
require 'modules/smarty/Smarty.class.php';
$smarty = new Smarty;

$smarty->template_dir = '../templates';
$smarty->compile_dir = '../templates_c';
$smarty->config_dir = '../lang';

$smarty -> config_overwrite = false;
$smarty->config_load($settings['language_file'], 'admin');
$lang = $smarty->get_config_vars();

// set local language settings:
setlocale(LC_ALL, $lang['locale']);

// go to login if not logged in:
if(empty($_SESSION[$settings['session_prefix'].'user_id'])) $mode = 'login';

// get mode:
if(empty($mode) && isset($_REQUEST['mode']))
 {
  switch($_REQUEST['mode'])
   {
    case 'edit': $mode = 'edit'; break;
    case 'pages': $mode = 'pages'; break;
    case 'menu': $mode = 'menu'; break;
    case 'photos': $mode = 'photos'; break;
    case 'gcb': $mode = 'gcb'; break;
    case 'notes': $mode = 'notes'; break;
    case 'comments': $mode = 'comments'; break;
    case 'filemanager': $mode = 'filemanager'; break;
    case 'spam_protection': $mode = 'spam_protection'; break;
    case 'user': $mode = 'user'; break;
    case 'settings': $mode = 'settings'; break;
    case 'image': $mode = 'image'; break;
    case 'thumbnail': $mode = 'thumbnail'; break;
    case 'logout': $mode = 'logout'; break;
    case 'ajaxprocess': $mode = 'ajaxprocess'; break;
    default: $mode = 'main'; break;
   }
 }
if(empty($mode)) $mode = 'main';

// include required file for mode:
switch($mode)
 {
  case 'main': include('includes/main.inc.php'); break;
  case 'login': include('includes/login.inc.php'); break;
  case 'logout': include('includes/login.inc.php'); break;
  case 'edit': include('includes/edit.inc.php'); break;
  case 'pages': include('includes/pages.inc.php'); break;
  case 'photos': include('includes/photos.inc.php'); break;
  case 'gcb': include('includes/gcb.inc.php'); break;
  case 'notes': include('includes/notes.inc.php'); break;
  case 'comments': include('includes/comments.inc.php'); break;
  case 'filemanager': include('includes/filemanager.inc.php'); break;
  case 'spam_protection': include('includes/spam_protection.inc.php'); break;
  case 'user': include('includes/user.inc.php'); break;
  case 'settings': include('includes/settings.inc.php'); break;
  case 'image': include('includes/image.inc.php'); break;
  case 'thumbnail': include('includes/thumbnail.inc.php'); break;
  case 'menu': include('includes/menu.inc.php'); break;
  case 'ajaxprocess': include('includes/ajaxprocess.inc.php'); break;
 }

// close SQLite database connection:
sqlite_close($db_content);
sqlite_close($db_entries);
?>
