<?php
/******************************************************************************
* phpSQLiteCMS - a simple and lightweight PHP web content management system   *                                                               *
* Copyright (C) 2008 alex@mylittlehomepage.net                                *
* http://phpsqlitecms.net/                                                    *
******************************************************************************/

/*******************************************************************************
* This program is free software: you can redistribute it and/or modify         *
* it under the terms of the GNU General Public License as published by         *
* the Free Software Foundation, either version 3 of the License, or            *
* (at your option) any later version.                                          *
*                                                                              *
* This program is distributed in the hope that it will be useful,              *
* but WITHOUT ANY WARRANTY; without even the implied warranty of               *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
* GNU General Public License for more details.                                 *
*                                                                              *
* You should have received a copy of the GNU General Public License            *
* along with this program.  If not, see <http://www.gnu.org/licenses/>.        *
*******************************************************************************/

session_start();

if(isset($_GET['cms_page'])) $cms_page = strtolower($_GET['cms_page']);
else $cms_page = '';

$cache_dir = '../cache/';

if(empty($_POST) && file_exists('../cache/settings.php'))
 { 
  include('../cache/settings.php');
  
  if($settings['caching']==1 && empty($_SESSION[$settings['session_prefix'].'user_id']))
   {
    if($cms_page=='') $cache_file = $settings['index_page'];
    else $cache_file = $cms_page;
    if(isset($_GET['get_1'])) $cache_file .= ','.$_GET['get_1'];
    if(isset($_GET['get_2'])) $cache_file .= ','.$_GET['get_2'];
    if(isset($_GET['get_3'])) $cache_file .= ','.$_GET['get_3'];
    if(isset($_GET['get_4'])) $cache_file .= ','.$_GET['get_4'];
    if(isset($_GET['get_5'])) $cache_file .= ','.$_GET['get_5'];
    $cache_file .= '.cache';
  
    if(file_exists($cache_dir.$cache_file))
     {
      include($cache_dir.$cache_file);
      exit;
     }
   }
 }
 
$error_403 = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en"><head><title>403 Forbidden</title><meta http-equiv="content-type" content="text/html; charset=iso-8859-1" /></head><body><h1>Forbidden</h1><p>You don\'t have permission to access this page.</p></body></html>';
$error_503 = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en"><head><title>503 Service Temporarily Unavailable</title><meta http-equiv="content-type" content="text/html; charset=iso-8859-1" /></head><body><h1>Service Temporarily Unavailable</h1><p>The server is currently unable to handle the request due to a temporary maintenance of the server. Please try again later.</p></body></html>';

define('IN_PARSER', TRUE);
include('config/db_settings.conf.php');
include('includes/functions.inc.php');

require('modules/smarty/Smarty.class.php');
$smarty = new Smarty;

$smarty->template_dir = '../templates';
$smarty->compile_dir = '../templates_c';
$smarty->config_dir = '../lang';

$smarty -> config_overwrite = false;
$smarty -> config_booleanize = false;

if(!$db_content = @sqlite_open($db_settings['db_content_file'])) db_error();
if(!$db_entries = @sqlite_open($db_settings['db_entry_file'])) db_error();

// Get settings, blocked IPs and user agents:
@sqlite_query($db_content, "BEGIN");
$settings_result = @sqlite_query($db_content, "SELECT name, value FROM ".$db_settings['settings_table']) or db_error();
$ips_result = @sqlite_query($db_content, "SELECT list FROM ".$db_settings['banlists_table']." WHERE name = 'ips' LIMIT 1");
$user_agents_result = @sqlite_query($db_content, "SELECT list FROM ".$db_settings['banlists_table']." WHERE name = 'user_agents' LIMIT 1");
@sqlite_query($db_content, "COMMIT");

// put settings into an array:
while ($line = sqlite_fetch_array($settings_result))
 {
  $settings[$line['name']] = stripslashes($line['value']);
 }

// define BASE_URL from settings or automatically:
if($settings['base_url']=='') define('BASE_URL', 'http://'.$_SERVER['HTTP_HOST'].substr(rtrim(dirname($_SERVER['PHP_SELF']), '/\\'),0,strrpos(rtrim(dirname($_SERVER['PHP_SELF']), '/\\'),'/cms')).'/');
else define('BASE_URL',$settings['base_url']);

// access permission check:
// Bad-Behavior:
if($settings['bad_behavior']==1)
 {
  require_once("modules/bad-behavior/bad-behavior-generic.php");
 }

// check IP:
$data = sqlite_fetch_array($ips_result);
if(trim($data['list']) != '')
 {
  $blocked_ips = explode(',',trim($data['list']));
  if(isset($blocked_ips) && in_array($_SERVER['REMOTE_ADDR'],$blocked_ips))
   {
    header($_SERVER['SERVER_PROTOCOL'] . " 403 Forbidden");
    header("Status: 403 Forbidden");
    echo $error_403;
    exit;
   } 
 }

// check user agent:
$data = sqlite_fetch_array($user_agents_result);
if(trim($data['list']) != '')
 {
  $banned_user_agents = explode(',',trim($data['list']));
  foreach($banned_user_agents as $banned_user_agent)
   {
    if($banned_user_agent!='' && (preg_match("/".$banned_user_agent."/i",$_SERVER['HTTP_USER_AGENT'])))
     {
      header($_SERVER['SERVER_PROTOCOL'] . " 403 Forbidden");
      header("Status: 403 Forbidden");
      echo $error_403;
      exit;
     }
   }
 }
// end access permission check

$smarty->assign('BASE_URL', BASE_URL);

// get data:
@sqlite_query($db_content, "BEGIN") or db_error();
// menus:
$menu_result = @sqlite_query($db_content, "SELECT DISTINCT menu FROM ".$db_settings['menu_table']) or db_error();
while ($data = sqlite_fetch_array($menu_result))
 {
  $menus[] = $data['menu'];
 }

if(isset($menus) && count($menus>0))
 {
  foreach($menus as $k)
   {
    $menu_result = @sqlite_query($db_content, "SELECT name, title, link, section, accesskey FROM ".$db_settings['menu_table']." WHERE menu = '".$k."' ORDER BY item_id ASC") or db_error();
    $i=0;
    while ($data = sqlite_fetch_array($menu_result))
     {
      $all_menus[$k][$i]['name'] = stripslashes($data['name']);
      $all_menus[$k][$i]['title'] = stripslashes($data['title']);
      $all_menus[$k][$i]['link'] = $data['link'];
      $all_menus[$k][$i]['section'] = $data['section'];
      $all_menus[$k][$i]['accesskey'] = $data['accesskey'];
      $i++;
     }
   }
 }

// global content blocks:
$gcb_result = @sqlite_query($db_content, "SELECT id, content, content_auto_html FROM ".$db_settings['gcb_table']." ORDER BY id ASC") or db_error();
while ($data = sqlite_fetch_array($gcb_result))
 {
  $gcb[$data['id']] = preg_replace('/\[\[([^|\]]+?)(?:\|([^\]]+))?\]\]/e', "'<a href=\"\$1\">'.(('\$2')?'\$2':'\$1').'</a>'",stripslashes($data['content']));
  if($data['content_auto_html']==1) $gcb[$data['id']] = auto_html($gcb[$data['id']]);
 }

// content:
if($cms_page == '') $cms_page = strtolower($settings['index_page']);
$content_result = @sqlite_query($db_content, "SELECT id, page, author, type, type_addition, time, last_modified, page_title, title, keywords, description, info_type, info, language_file, breadcrumbs, headline, teaser_headline, teaser, teaser_auto_html, content, content_auto_html, sidebar_1, sidebar_1_auto_html, sidebar_2, sidebar_2_auto_html, sidebar_3, sidebar_3_auto_html, sections, menu_1, menu_2, menu_3, gcb_1, gcb_2, gcb_3, template, content_type, charset, edit_permission, edit_permission_general, custom_values FROM ".$db_settings['content_table']." WHERE lower(page)='".sqlite_escape_string(strtolower($cms_page))."' AND page_status=1 LIMIT 1") or db_error();
if(sqlite_num_rows($content_result)!=1) $invalid_page = true;

@sqlite_query($db_content, "COMMIT") or db_error();

if(isset($_GET['get_1']) && $_GET['get_1']=='photo')
 {
  include('includes/photo.inc.php');
 }
elseif(isset($_GET['get_1']) && $_GET['get_1']=='__slideshow')
 {
  include('includes/slideshow.inc.php');
 }

if(empty($template_done))
 {
  if(isset($invalid_page))
   {
    $no_cache = true;
    $content_result = @sqlite_query($db_content, "SELECT id, page, author, type, type_addition, time, last_modified, page_title, title, description, keywords, info_type, info, language_file, breadcrumbs, headline, teaser_headline, teaser, teaser_auto_html, content, content_auto_html, sidebar_1, sidebar_1_auto_html, sidebar_2, sidebar_2_auto_html, sidebar_3, sidebar_3_auto_html, sections, menu_1, menu_2, menu_3, gcb_1, gcb_2, gcb_3, template, content_type, charset, edit_permission, edit_permission_general, custom_values FROM ".$db_settings['content_table']." WHERE page='".sqlite_escape_string($settings['error_page'])."' AND page_status=1 LIMIT 1") or db_error();
    header($_SERVER['SERVER_PROTOCOL'] . " 404 Not Found");
    header("Status: 404 Not Found");
    if(sqlite_num_rows($content_result) != 1) die('404');
   }

  if(isset($all_menus)) $smarty->assign('menus', $all_menus);
  if(isset($gcb)) $smarty->assign('gcb', $gcb);

  $data = sqlite_fetch_array($content_result);

  // count views:
  if($settings['count_views']==1)
   {
    @sqlite_query($db_content, "UPDATE ".$db_settings['content_table']." SET views=views+1 WHERE id = ".$data['id']) or db_error();
   }

  // breadcrumbs:
  $breadcrumbs_array = explode(',',$data['breadcrumbs']);
  #$breadcrumbs = array();
  @sqlite_query($db_content, "BEGIN");
  $i=0;
  foreach($breadcrumbs_array as $breadcrumb)
   {
    if(!empty($breadcrumb))
     {
      $breadcrumb_result = @sqlite_query($db_content, "SELECT page, title FROM ".$db_settings['content_table']." WHERE id=".intval($breadcrumb)." LIMIT 1") or db_error();
      $breadcrumb_data = sqlite_fetch_array($breadcrumb_result);
      $breadcrumbs[$i]['page'] = $breadcrumb_data['page'];
      $breadcrumbs[$i]['title'] = stripslashes($breadcrumb_data['title']);
      ++$i;
     }
   }
  @sqlite_query($db_content, "COMMIT");
  if(isset($breadcrumbs))
   {
    $smarty->assign('breadcrumbs', $breadcrumbs);
   }
  
  $page = stripslashes($data['page']);

  $content = stripslashes($data['content']);
  if($settings['content_auto_link']==1) $content = make_link($content);
  if($settings['content_smilies']==1) $content = smilies($content);
  if($data['content_auto_html']==1) $content = auto_html($content);

  if($settings['content_function']==1) $content = preg_replace_callback("#\[function:(.+?)\]#is", "content_function", $content);
  $content = preg_replace_callback("#\[image:(.+?)\]#is", "create_image", $content);
  $content = preg_replace_callback("#\[thumbnail:(.+?)\]#is", "create_thumbnail", $content);
  $content = preg_replace_callback("#\[gallery:(.+?)\]#is", "create_gallery", $content);
  $content = stripslashes(preg_replace('/\[\[([^|\]]+?)(?:\|([^\]]+))?\]\]/e', "'<a href=\"\$1\">'.(('\$2')?'\$2':'\$1').'</a>'", $content));
   
  $sidebar_1 = stripslashes($data['sidebar_1']);
  if($settings['content_auto_link']==1) $sidebar_1 = make_link($sidebar_1);
  if($settings['content_smilies']==1) $sidebar_1 = smilies($sidebar_1);
  if($data['sidebar_1_auto_html']==1) $sidebar_1 = auto_html($sidebar_1);
  if($sidebar_1!='') $sidebar_1 = stripslashes(preg_replace('/\[\[([^|\]]+?)(?:\|([^\]]+))?\]\]/e', "'<a href=\"\$1\">'.(('\$2')?'\$2':'\$1').'</a>'", $sidebar_1));
  
  $sidebar_2 = stripslashes($data['sidebar_2']);
  if($settings['content_auto_link']==1) $sidebar_2 = make_link($sidebar_2);
  if($settings['content_smilies']==1) $sidebar_2 = smilies($sidebar_2);
  if($data['sidebar_2_auto_html']==1) $sidebar_2 = auto_html($sidebar_2);
  if($sidebar_2!='') $sidebar_2 = stripslashes(preg_replace('/\[\[([^|\]]+?)(?:\|([^\]]+))?\]\]/e', "'<a href=\"\$1\">'.(('\$2')?'\$2':'\$1').'</a>'", $sidebar_2));
  
  $sidebar_3 = stripslashes($data['sidebar_3']);
  if($settings['content_auto_link']==1) $sidebar_3 = make_link($sidebar_3);
  if($settings['content_smilies']==1) $sidebar_3 = smilies($sidebar_3);
  if($data['sidebar_3_auto_html']==1) $sidebar_3 = auto_html($sidebar_3);
  if($sidebar_3!='') $sidebar_3 = stripslashes(preg_replace('/\[\[([^|\]]+?)(?:\|([^\]]+))?\]\]/e', "'<a href=\"\$1\">'.(('\$2')?'\$2':'\$1').'</a>'", $sidebar_3));
  
  $sections_array = explode(',',stripslashes($data['sections']));
  foreach($sections_array as $section)
   {
    $sections[] = $section;
   }  
  $smarty->assign('section', $sections);

  $custom_values_array = explode(',',stripslashes($data['custom_values']));
  foreach($custom_values_array as $custom_value)
   {
    $custom_values[] = $custom_value;
   }  
  $smarty->assign('custom_value', $custom_values);
      
  $page_id = $data['id'];
  
  $smarty->assign('info_type', $data['info_type']);
  $smarty->assign('id', $data['id']);
  $smarty->assign('page', $page);
  $smarty->assign('settings', $settings);
  $smarty->assign('type', $data['type']);
  #$smarty->assign('category_1', stripslashes($data['category_1']));
  #$smarty->assign('category_2', stripslashes($data['category_2']));
  #$smarty->assign('category_3', stripslashes($data['category_3']));
  $smarty->assign('title', stripslashes($data['title']));
  $smarty->assign('page_title', stripslashes($data['page_title']));
  $smarty->assign('keywords', stripslashes($data['keywords']));
  $smarty->assign('description', stripslashes($data['description']));
  $smarty->assign('headline', stripslashes($data['headline']));
  $smarty->assign('headline', stripslashes($data['headline']));
  $smarty->assign('content', $content);
  $smarty->assign('sidebar_1', $sidebar_1);
  $smarty->assign('sidebar_2', $sidebar_2);
  $smarty->assign('sidebar_3', $sidebar_3);
  $smarty->assign('menu_1', stripslashes($data['menu_1']));
  $smarty->assign('menu_2', stripslashes($data['menu_2']));
  $smarty->assign('menu_3', stripslashes($data['menu_3']));
  $smarty->assign('gcb_1', intval($data['gcb_1']));
  $smarty->assign('gcb_2', intval($data['gcb_2']));
  $smarty->assign('gcb_3', intval($data['gcb_3']));
  
  if(isset($_SESSION[$settings['session_prefix'].'user_id'])) 
   {
    $smarty->assign('admin', true);
    if(is_authorized_to_edit($_SESSION[$settings['session_prefix'].'user_id'],$_SESSION[$settings['session_prefix'].'user_type'],$data['author'],$data['edit_permission'],$data['edit_permission_general']))
     {
      $smarty->assign('authorized_to_edit', true);
     }
   }

  if($data['language_file']=='') $language_file = $settings['language_file'];
  else $language_file = $data['language_file'];
  $smarty->config_load($language_file);
  $lang = $smarty->get_config_vars();
  setlocale(LC_ALL, $lang['locale']);
  $smarty->assign('config_file', $language_file);

  $smarty->assign('timestamp', $data['time']);
  
  $smarty->assign('created', format_time($lang['time_format'], $data['time']));
  $smarty->assign('last_modified', format_time($lang['time_format'], $data['last_modified']));
  if($data['info_type']==1) $info = format_time($lang['time_format_full'], $data['time']);
  
  if($data['info_type']!=1) $info = stripslashes($data['info']);
  $smarty->assign('info', $info);
  
  if($data['content_type']=='') $content_type = 'text/html';
  else $content_type = $data['content_type'];
  if($data['charset']=='') $charset = $lang['charset'];
  else $charset = $data['charset'];

  $smarty->assign('content_type', $content_type);
  $smarty->assign('charset', $charset);
  $smarty->assign('lang', $lang['lang']);

  if($data['type']!='default')
   {
    include('config/page_types.conf.php');
    if(isset($page_types[$data['type']]['page_type'])) include('page_types/'.$page_types[$data['type']]['page_type']);
   }

  if(empty($template_done))
   {
    header('Content-Type: '.$content_type.'; charset='.$charset);
    $smarty->display($data['template']);
    if($settings['caching']==1 && empty($_SESSION[$settings['session_prefix'].'user_id']) && empty($no_cache) && empty($_POST))
     {
      $cache_content = '<?php header(\'Content-Type: '.$content_type.'; charset='.$charset.'\'); ?'.'>'.$smarty->fetch($data['template']);
      if(empty($new_cache_file)) $new_cache_file = $cms_page.'.cache';
      create_chache_file($cache_dir.$new_cache_file, $cache_content);
      if(!file_exists($cache_dir.'settings.php')) create_cache_settings_file($cache_dir.'settings.php');
     } 
   }
 }

// close database:
@sqlite_close($db_content);
@sqlite_close($db_entries);